import {
  PerspectiveCamera,
  Scene,
  Vector2,
  ColorRepresentation,
  Renderer as ThreeRenderer,
  Camera,
  Event,
  Object3D,
} from 'three';
import { Renderer } from '../types/renderer';

export class NoopThreeRenderer implements ThreeRenderer {
  domElement = document?.createElement('canvas');

  render(scene: Object3D<Event>, camera: Camera): void {
    // stub
  }

  setSize(width: number, height: number, updateStyle?: boolean): void {
    // stub
  }
}

export class StubRenderer implements Renderer {
  public renderer = new NoopThreeRenderer();
  public camera = new PerspectiveCamera(
    75,
    this.resolution.x / this.resolution.y,
    0.1,
    10000
  );
  public scene = new Scene();

  constructor(
    public viewport: HTMLElement,
    public resolution = new Vector2(1080, 720),
    private params = {}
  ) {}

  setSize(width: number, height: number) {
    this.resolution.set(width, height);
    this.camera.aspect = this.resolution.x / this.resolution.y;
    this.camera.updateProjectionMatrix();
  }

  render() {
    // stub
  }

  dispose() {
    // stub
  }

  setClearColor(color: ColorRepresentation, alpha?: number): void {
    // stub
  }

  reset(): void {
    // stub
  }
}
