import { Quaternion, Vector3 } from 'three';

export enum CharacterAccessoryType {
  Hat = 'Hat',
  Face = 'Face',
  Tool = 'Tool',
  Front = 'Front',
  Back = 'Back',
}

export enum CharacterTextureType {
  TShirt = 'TShirt',
  Shirt = 'Shirt',
  Pants = 'Pants',
  Face = 'Face',
}

export interface CharacterAccessoryMapped {
  Parent: string;
  Origin: Vector3;
  Quat: Quaternion;
}

export interface CharacterSpecificationMapped {
  Version: number;
  Accessories: string[];
  Accessory: Record<CharacterAccessoryType, CharacterAccessoryMapped>;
  Texture: Record<CharacterTextureType, string[]>;
  Bones: string[];
  Parts: string[];
  ColorParts: string[];
  MinScale: number;
  MaxScale: number;
  UnitHeight: number;
}

export interface CharacterBodyPartAccessory {
  type: CharacterAccessoryType;
  origin: Vector3;
  quaternion: Quaternion;
}

export interface CharacterBodyPart {
  meshName: string;
  boneName: string;
  colored: boolean;
  textures: CharacterTextureType[];
  accessories: CharacterBodyPartAccessory[];
}

export interface CharacterSpecification {
  assetId?: string;
  info: CharacterSpecificationMapped;
  bodyParts: CharacterBodyPart[];
}
